#include <iostream>
using namespace std;

// Define a Estrutura N
struct No {
    int valor;      // Valor armazenado
    No * prox;      // Ponteiro para prximo elemento da lista
};

// Insere valor no incio da lista
No * inserirInicio(No * lista, int valor);
// Remove elemento do incio da lista
No * removerInicio(No * lista, int &valor);

int main(void) {
    // Declara lista vazia
    No * pilha = NULL;

   // Varivel para armazenar dado digitado
    int dado;
    // Varivel que indica se acabaram valores da pilha
    int vazia;
    // Valor de calculo
    int resto, quociente;

    cout << "Digite um numero inteiro: ";
    cin >> dado;

    do {
        quociente = dado / 2;
        resto = dado % 2;
        pilha = inserirInicio(pilha, resto);
        dado = quociente;
    } while(dado > 0);

    // Agora mostra o reultado...
    do {
        pilha = removerInicio(pilha, dado);
        cout << dado;
    } while (pilha != NULL);

    cout << "b" << endl;
}

// Insere um valor no incio da lista
No * inserirInicio(No * lista, int valor) {
    No * tmp; // Ponteiro para armazenar endereo de n temporariamente
    // Cria n
    tmp = new No;
    // Configura n...
    tmp->valor = valor; // Valor do n
    tmp->prox = lista; // Prximo n  o antigo incio da lista
    // Aponta incio da lista para o novo n
    lista = tmp;
    // Retorna o novo incio da lista
    return lista;
}

// Remove um n do incio da lista, retornando seu valor
No * removerInicio(No * lista, int &valor) {
    No * tmp; // Ponteiro temporrio
    // Se a lista est vazia, vai embora
    if (lista == NULL) return NULL;
    // Armazena valor do elemento sendo removido
    valor = lista->valor;
    // Armazena endereo de elemento a ser removido
    tmp = lista;
    // Aponta inicio da lista para segundo elemento
    lista = lista->prox;
    // Remove o primeiro elemento da lista
    delete tmp;
    // Retorna novo incio da lista
    return lista;
}

